module IBUF(O, I);
	input I;
	output O;

	assign O = I;
endmodule

module IOBUF(O, IO, I, T);
	input T;
	input I;
	output O;
	inout IO;

	assign IO = T ? 1'bz : I;
	assign O = IO;
endmodule

module BUFG(O, I);
	input I;
	output O;

	assign O = I;
endmodule

module OBUF(O, I);
	input I;
	output O;

	assign O = I;
endmodule

module IBUFG(I, O);
	input I;
	output O;

	assign O = I;
endmodule

module OBUFT(I, O, T);
	input I;
	input T;
	output O;

	assign O = T ? 1'bz : I;
endmodule

module OBUFE(O, E, I);
	input I;
	input E;
	output O;

	assign O = E ? I : 1'bz;
endmodule

module IOBUFE(O, IO, I, E);
	input I;
	input E;
	inout IO;
	output O;

	assign O = IO;
	assign IO = E ? 1'bz : I;
endmodule

module IOBUFE8(O, IO, I, E);
	input [7:0] I;
	input E;
	inout [7:0] IO;
	output [7:0] O;

	IOBUFE buf0(O[0], IO[0], I[0], E);
	IOBUFE buf1(O[1], IO[1], I[1], E);
	IOBUFE buf2(O[2], IO[2], I[2], E);
	IOBUFE buf3(O[3], IO[3], I[3], E);
	IOBUFE buf4(O[4], IO[4], I[4], E);
	IOBUFE buf5(O[5], IO[5], I[5], E);
	IOBUFE buf6(O[6], IO[6], I[6], E);
	IOBUFE buf7(O[7], IO[7], I[7], E);
endmodule
